/* ELECTRONOOBS 2023
 * NOTE: Run the ATtiny85 at 1-MHz internal clock
 * This requires "Burn Bootloader" to be run first
 * The "0" bit: 188us
 * The "1" bit: 3x zero bit length
 * Sync (start) time: 30x zero bit
 * Message length: 24 data bits, 1 stop bit*/


#include <avr/sleep.h>

//Input/Outputs
#define Serial_RF 3               //Pin for the radio transmitter part
#define Button1 2                 //Button 1 pin
#define Button2 1                 //Button 2 pin
#define Button3 0                 //Button 3 pin
#define LED_Pin 4                 //Button 3 pin

//Variables used in the code
#define DelayShort 188
#define DelayLong 564
#define DelaySync 5640

bool button1_state = true;    //Store the value of the button when pressed
bool button2_state = true;    //Store the value of the button when pressed
bool button3_state = true;    //Store the value of the button when pressed


void setup (){
  pinMode(Serial_RF, OUTPUT);
  digitalWrite(Serial_RF, LOW);
  pinMode(Button1, INPUT_PULLUP);
  pinMode(Button2, INPUT_PULLUP);
  pinMode(Button3, INPUT_PULLUP);
  pinMode(LED_Pin, OUTPUT);
  digitalWrite(LED_Pin, LOW);
  bitClear(ADCSRA, ADEN);         // disable ADC for low power mode
}  // end of setup

void loop (){
  if (!digitalRead(Button1) && button1_state){
    button1_state = false;
    Transmit1();
    delay(100);
  }
  else if (digitalRead(Button1) && !button1_state){
    button1_state = true;
    delay(100);
  }  
  
} // end of loop



void Transmit1 (){  
  //Send the code 3 times just in case
  Write_RF(0x33);
  Write_RF(0x45);
  Write_RF(0x15);
  Stop_Bit();
  delayMicroseconds(DelaySync);   
  Write_RF(0x33);
  Write_RF(0x45);
  Write_RF(0x15);
  Stop_Bit();
  delayMicroseconds(DelaySync);
  Write_RF(0x33);
  Write_RF(0x45);
  Write_RF(0x15);
  Stop_Bit();
  delayMicroseconds(DelaySync);
}



void Write_RF (byte Data_Byte){
  byte i = 8; // send MSB first
  while (i > 0){
    i--;
    digitalWrite(Serial_RF, 1);
    if (bitRead(Data_Byte, i) == 0){
      delayMicroseconds(DelayShort);
      digitalWrite(Serial_RF, 0);
      delayMicroseconds(DelayLong);
    }
    else{
      delayMicroseconds(DelayLong);
      digitalWrite(Serial_RF, 0);
      delayMicroseconds(DelayShort);
    }
  }
}


void Stop_Bit (){
  digitalWrite(Serial_RF, 1);
  delayMicroseconds(DelayShort);
  digitalWrite(Serial_RF, 0);
  delayMicroseconds(DelayLong);
}
